=== debian/changelog ===
nfs-ganesha (4.0.8-2) unstable; urgency=medium

  * Source only upload

 -- Christoph Martin <martin@uni-mainz.de>  Tue, 13 Sep 2022 11:33:43 +0200

nfs-ganesha (4.0.8-1) unstable; urgency=medium

  * New upstream version 4.0.8
  * move ganesha_rados libraries to nfs-ganesha-ceph package
  * add blank lines to description to seperate identical description block
    (closes: #1001269)

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 12 Sep 2022 15:38:19 +0200
