=== debian/changelog ===
nfs-ganesha (4.0.12-3~bpo11+1) bullseye-backports; urgency=medium

  * Backports rebuild

 -- Christoph Martin <martin@uni-mainz.de>  Fri, 20 Jan 2023 11:56:33 +0100

nfs-ganesha (4.0.12-3) unstable; urgency=medium

  * remove ganesha-rados-grace from python3-nfs-ganesha (closes: #1028501)

 -- Christoph Martin <martin@uni-mainz.de>  Thu, 12 Jan 2023 12:29:59 +0100

nfs-ganesha (4.0.12-2) unstable; urgency=medium

  * fix FTBS because of changed behavior of python3-setuptools
    (closes: #1027572)
  * include missing scripts and manpage in python3-nfs-ganesha
  * fix nfs-ganesha-proxy-v4 manpage install

 -- Christoph Martin <martin@uni-mainz.de>  Wed, 11 Jan 2023 16:35:34 +0100

nfs-ganesha (4.0.12-1~bpo11+1) bullseye-backports; urgency=medium

  * Backports rebuild

 -- Christoph Martin <martin@uni-mainz.de>  Tue, 15 Nov 2022 13:10:54 +0100

nfs-ganesha (4.0.12-1) unstable; urgency=medium

  * New upstream version 4.0.12

 -- Christoph Martin <martin@uni-mainz.de>  Tue, 08 Nov 2022 14:08:20 +0100

nfs-ganesha (4.0.8-1~bpo11+1) bullseye-backports; urgency=medium

  * backports rebuild

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 12 Sep 2022 13:46:10 +0200

nfs-ganesha (3.5-1~bpo11+1) bullseye-backports; urgency=medium

  * backports rebuild

 -- Christoph Martin <martin@uni-mainz.de>  Tue, 01 Feb 2022 14:12:16 +0100
