=== debian/control ===
--- 
+++ 
@@ -58,6 +58,7 @@
 Architecture: all
 Depends: ${misc:Depends}, ${shlibs:Depends},
          nfs-ganesha (>=${source:Version})
+Multi-Arch: foreign
 Description: nfs-ganesha mount.9P
  NFS-GANESHA is a NFS Server running in user space with a large cache.
  It comes with various backend modules to support different file systems
@@ -82,7 +83,6 @@
  This package contains a library for FSAL_GLUSTER and an example .conf file
 
 Package: nfs-ganesha-ceph
-Multi-Arch: same
 Architecture: any
 Section: libs
 Depends: ${misc:Depends}, ${shlibs:Depends},
@@ -216,6 +216,7 @@
 Architecture: all
 Section: doc
 Depends: ${misc:Depends}
+Multi-Arch: foreign
 Description: Documentation for nfs-ganesha
  NFS-GANESHA is a NFS Server running in user space with a large cache.
  It comes with various backend modules to support different file systems
